/* This file is part of the Views Template Library, written by
 * Gary Powell & Martin Weiser
 *
 * Copyright (c) 1999  Gary Powell
 * Copyright (c) 1999  Konrad Zuse Zentrum fuer Informationstechnik Berlin
 *
 * This material is provided "as is", with absolutely no warranty expressed
 * or implied. Any use is at your own risk.
 *
 * Permission to use or copy this software for any purpose is hereby granted 
 * without fee, provided the above notices are retained on all copies.
 * Permission to modify the code and to distribute modified code is granted,
 * provided the above notices are retained, and a notice that the code was
 * modified is included with the above copyright notice.
 */

#if !defined(_STL_FWDFUNCTIONAL_HPP)
#define _STL_FWDFUNCTIONAL_HPP

#if !defined(_VIEW_CONFIG_HPP)
#include "view_config.hpp"
#endif

#if !defined (USE_FORWARD_DECLARATIONS_OF_STD_FUNCTIONAL)

#if !defined(_SYS_LIBRARY_FUNCTIONAL_)
#include <functional>
#define _SYS_LIBRARY_FUNCTIONAL_
#endif // _SYS_LIBRARY_FUNCTIONAL_

#else
// forward declaration so we don't have to include <functional>
namespace std {
template<class _A, class _R>
	struct unary_function;

template<class _A1, class _A2, class _R>
	struct binary_function;

template <class _Tp> struct less;

template<class _Ty> struct equal_to;

template<class _Ty> struct logical_not;
};

#endif // USE_FORWARD_DECLARATIONS_OF_STD_FUNCTIONAL

#endif	 // _STL_FWDALGORITHM_HPP
// $Id: stl_functional_fwd.hpp,v 1.2 2000/04/28 08:20:20 bzfweise Exp $
