/* This file is part of the Views Template Library, written by
 * Gary Powell & Martin Weiser
 *
 * Copyright (c) 1999  Gary Powell
 * Copyright (c) 1999  Konrad Zuse Zentrum fuer Informationstechnik Berlin
 *
 * This material is provided "as is", with absolutely no warranty expressed
 * or implied. Any use is at your own risk.
 *
 * Permission to use or copy this software for any purpose is hereby granted 
 * without fee, provided the above notices are retained on all copies.
 * Permission to modify the code and to distribute modified code is granted,
 * provided the above notices are retained, and a notice that the code was
 * modified is included with the above copyright notice.
 */

//
// Traits classes that map container types and constness tags to iterator types.
//

#if!defined(_VIEW_BASE_FWD_HPP)
#define _VIEW_BASE_FWD_HPP

#if !defined(_VIEW_CONFIG_HPP)
#include "view_config.hpp"
#endif


BEGIN_VIEW_NAMESPACE
//
// Tag classes used for telling views whether their referenced containers
// should be const or mutable.
//
class mutable_view_tag;
class const_view_tag;

template<class container, class const_tag>
class view_own;

template<class container, class const_tag>
class view_ref;

END_VIEW_NAMESPACE

#endif // _VIEW_BASE_FWD_HPP
// $Id: view_base_fwd.hpp,v 1.2 2000/04/28 08:20:23 bzfweise Exp $
