/* This file is part of the Views Template Library, written by
 * Gary Powell & Martin Weiser
 *
 * Copyright (c) 1999  Gary Powell
 * Copyright (c) 1999  Konrad Zuse Zentrum fuer Informationstechnik Berlin
 *
 * This material is provided "as is", with absolutely no warranty expressed
 * or implied. Any use is at your own risk.
 *
 * Permission to use or copy this software for any purpose is hereby granted 
 * without fee, provided the above notices are retained on all copies.
 * Permission to modify the code and to distribute modified code is granted,
 * provided the above notices are retained, and a notice that the code was
 * modified is included with the above copyright notice.
 */

#if !defined(_ZIP_VIEW_FWD_HPP)
#define _ZIP_VIEW_FWD_HPP

#if !defined(_VIEW_CONFIG_HPP)
#include "view_config.hpp"
#endif

#if !defined(_VIEW_BASE_FWD_HPP)
#include "view_base_fwd.hpp"
#endif

#if !defined(_VIEW_TRAITS_HPP)
#include "view_traits.hpp"
#endif

// A forward declaration of every public view.
// The purpose is that if you have an include file that has a pointer to a view in
// it you don't need to include the full view.hpp file. Instead you can include just this
// file. Then the .cpp file can include the full view.hpp file and then use it.
// For each view, I have included the view and the iterator declaration if necessary.

BEGIN_VIEW_NAMESPACE

template <class T1, class T2>
struct reference_pair;

template <class iter_t_a, class iter_t_b,
          template<class A, class B> class combinator,	// ref_pair
          class range_t>	
class zip_iterator;

template <class container_a, class container_b,
          class const_tag = const_view_tag,
          template<class A, class B> class combinator = reference_pair,
          class iterator_tag = typename combine_iterator_tags<typename container_a::iterator,
							      typename container_b::iterator>::type,
          template<class container, class const_tag> class proxy_template_a = view_ref,
          template<class container, class const_tag> class proxy_template_b = view_ref>
class zip_view;

END_VIEW_NAMESPACE

#endif // _ZIP_VIEW_FWD_HPP
