/* This file is part of the Views Template Library, written by
 * Gary Powell & Martin Weiser
 *
 * Copyright (c) 1999  Gary Powell
 * Copyright (c) 1999  Konrad Zuse Zentrum fuer Informationstechnik Berlin
 *
 * This material is provided "as is", with absolutely no warranty expressed
 * or implied. Any use is at your own risk.
 *
 * Permission to use or copy this software for any purpose is hereby granted 
 * without fee, provided the above notices are retained on all copies.
 * Permission to modify the code and to distribute modified code is granted,
 * provided the above notices are retained, and a notice that the code was
 * modified is included with the above copyright notice.
 */

#include "symmetric_difference_view.hpp"

#include <set>
#include <cstdlib>
#include <map>
#include <vector>
#include <iostream>
#include <numeric>

#include "dump.h"
#include "iterator_test.h"

using std::cout;
using std::cin;
using std::endl;
using std::vector;
using std::map;
using std::set;
using std::iota;
using std::advance;

USING_VIEW_NAMESPACE

namespace {

using std::ostream;

template <class A, class B>
ostream& operator<<(ostream& out, pair<A,B> const& p) {
  return out << "(" << p.first << "," << p.second << ")";
}

};


int main()
{
#if 0
  vector<int> x(5), y(9);
  iota (x.begin(), x.end(), 0);
  iota (y.begin(), y.end(), 3);

  typedef symmetric_difference_view<vector<int>, vector<int> > diff_view;
  typedef symmetric_difference_view<vector<int>, vector<int>, mutable_view_tag > mdiff_view;

  diff_view	dview(x, y);

  cout << "Symmetric Difference Test: you should not see the numbers 3, 4:" << endl;
  dump(cout, dview);

  forward_test(dview);
  const_forward_test(dview);

  mdiff_view mdview(x,y);

  forward_test(mdview);
  const_forward_test(mdview);

  set<int> z;
  for (int j = 3; j < 9; ++j)
	  z.insert(j);


  typedef symmetric_difference_view<set<int>, vector<int> > diffSetVec_view;
  diffSetVec_view	dsview(z, x);

  cout << "Symmetric Difference Test: you should not see the numbers 3, 4:" << endl;
  dump(cout, dsview);

  map<int,int> mx, my;
  for (int i=0; i<15; ++i) {
    mx[i] = (i*i)%3;
    my[i+2] = (7*i)%5;
  }

  typedef symmetric_difference_view< map<int,int>, map<int,int> > diffMap_view;
  diffMap_view dmview(mx,my);

  cout << "Symmetric Difference set Test:" << endl;
  dump(cout,mx);
  dump(cout,my);
  cout << "-> ";
  dump(cout,dmview);
#endif

  cout << "type q <cr> to exit app. ";
  char c;
  do {
    cin >> c;
    cout << c;
  } while (c != 'q');
    
  cout << endl;
  return EXIT_SUCCESS;
}

